// FT_M*() mouse test = slightly extended original source from nanfor
// Mouse functions are available in vfs_mouse.prg applicamle for GUI mode 

#ifdef FlagShip 
# include "mouse.fh"
#endif
    
FUNCTION MAIN(nRow,nCol)

* Pass valid row and column values for different video modes to change modes

   local nX, nY, cSavClr
   local cSavScr := savescreen( 0, 0, maxrow(), maxcol() )
   local nXm, nYm
   local nSaveRow:=MAXROW()+1, nSaveCol:=MAXCOL()+1
   local nMinor, nType, nIRQ
   local aType:={"Bus","Serial","InPort","PS/2","HP"}
   local nHoriz, nVert, nDouble
   local nTime

   SET FONT "courier",10       // FlagShip GUI  
   SET GUICOLOR ON
        
	IF empty(nRow)
		nRow=MAXROW()+1
	ELSE
		nRow=VAL(nRow)
	ENDIF

	IF empty(nCol)
		nCol=MAXCOL()+1
	ELSE
		nCol=VAL(nCol)
	ENDIF

	IF .NOT.SETMODE(nRow,nCol)
		@maxrow(),0 SAY "Mode Change unsuccessful:"+STR(nRow,2,0)+" by "+STR(nCol,3,0)
      wait 
		* RETURN NIL
	ENDIF

     if empty( FT_MINIT() )
        @ maxrow(), 0 say "Mouse driver is not installed!"
        SETMODE(nSaveRow,nSaveCol)
        wait 
        * return ""
     endif

#ifdef FlagShip     
   for nType := 3 to 3
     cSavClr := setcolor(if(AppIoMode() == "G", "N/?", "w/n"))
     cDots := " "
     for ii := 1 to (nCol / 10) + 1
         cDots += str(ii * 10, 10)
     next
     cDots := left(strtran(cDots, " ", "."), maxcol())
     for ii := 0 to maxrow()
        @ ii,0 say cDots
        @ ii,0 say ltrim(ii)
     next 
#else
   for nType := 1 to len(aType)
     * ..... Set up the screen
     cSavClr := setcolor( "w/n" )
     @ 0,0,maxrow(),maxcol() box "........."
#endif   

     setcolor( "GR+/RB" )
     scroll( 7,2,19,63,0 )
     @ 7,2 to 20,63

     @ 17, 10 to 19, 40 double

     setcolor( "N/W" )
     @ 18, 11 say "  Double Click here to Quit  "

     setcolor( "GR+/RB" )

     * ..... Start the demo

   	@MAXROW(),0 SAY "Driver version: "+;
		ALLTRIM(STR(FT_MVERSION(@nMinor,@nType,@nIRQ),2,0))+"."+;
		ALLTRIM(STR(nMinor,2,0))
#ifdef FlagShip     
     @ ROW(),COL() SAY " "+aType[nType]+" mouse"
#else
     @ ROW(),COL() SAY " "+aType[nType]+" mouse using IRQ "+STR(nIRQ,1,0)
#endif   

     FT_MGETSENS(@nHoriz,@nVert,@nDouble)  // Get the current sensitivities
	  FT_MSETSENS(70,70,60)    // Bump up the sensitivity of the mouse

     FT_MSHOWCRS()
     FT_MSETCOORD(10,20)  // just an arbitrary place for demo

* put the unchanging stuff

     devpos( 9, 10 )
     devout( "FT_MMICKEYS :" )

     devpos( 10, 10 )
     devout( "FT_MGETPOS  :" )

     devpos( 11, 10 )
     devout( "FT_MGETX    :" )

     devpos( 12, 10 )
     devout( "FT_MGETY    :")

     devpos( 13, 10 )
     devout( "FT_MGETCOORD:" )

     devpos( 14, 10 )
     devout( "FT_MBUTPRS  :" )

     devpos( 16, 10 )
     devout( "FT_MBUTREL  :" )

     nX := nY := 1
     do while .t.

* If we are not moving then wait for movement.
* This whole demo is a bit artificial in its requirements when compared
* to a "normal" CLIPPER program so some of these examples are a bit out of
* the ordinary.

        DO WHILE nX=0.AND.nY=0
             FT_MMICKEYS( @nX, @nY )
        ENDDO
* tell the mouse driver where updates will be taking place so it can hide
* the cursor when necessary.

        FT_MCONOFF( 9, 23, 16, 53 )
        nTime=-1

        devpos( 9, 23 )
        devout( nX )
        devout( nY )

        devpos( 10, 23 )
        DEVOUT( FT_MGETPOS( @nX, @nY ) )
        devout( nX )
        devout( nY )

        devpos( 11, 23 )
        DEVOUT(  FT_MGETX() )

        devpos( 12, 23 )
        DEVOUT( FT_MGETY() )

        devpos( 13, 23 )
        devout( FT_MGETCOORD( @nX, @nY ) )
        devout ( nX )
        devout ( nY )

        nX:=nY:=0
        devpos( 14, 23 )
        DEVOUT( FT_MBUTPRS(1) )
        DEVOUT( FT_MBUTPRS(0,, nX, nY) )
        devpos( 15, 23 )

* show only the last Press since it flashes by so quickly

        IF nX!=0.OR.nY!=0
             devout( nX )
             devout( nY )
        endif

        nX:=nY:=0
        devpos( 16, 23 )
        devout( FT_MBUTREL(0,, @nX, @nY) )

* show only the last release since it flashes by so quickly

        if nX!=0.OR.nY!=0
             devout( nX )
             devout( nY )
        endif

* Restore the cursor if it has been hidden

        FT_MSHOWCRS()

        if FT_MINREGION( 18, 11, 18, 39 )

* Change the type of cursor when in the box. Just slightly different than the
* normal. The character is shown in high intensity.

           FT_MDEFCRS(0,32767,32512)
           if FT_MDBLCLK(2,0,0.8)
              exit
           endif
        endif

        if FT_MINREGION( 18, 11, 18, 39 )

* Change the type of cursor when in the box. Just slightly different than the
* normal. The character is shown in high intensity.

           FT_MDEFCRS(0,32767,32512)
        else

* Put the cursor back to normal mode

           FT_MDEFCRS(0,30719,30464)
        endif

        FT_MMICKEYS( @nX, @nY )
        
        if inkey() == K_ESC
           exit
        endif
     enddo
#ifdef FlagShip
     setcolor( "GR+/RB" )
     scroll( 7,2,19,63,0 )
     @ 7,2 to 20,63
     aStat := Mstate()
     @ 9, 8 say  "Left mouse  " + ltrim(aStat[BUTTON_MSTATE_LCOUNT]) + ;
                 "-times pressed, last at row/col " + ;
                 ltrim(round(Pixel2row(aStat[BUTTON_MSTATE_LROW]),0)) + "/" + ;
                 ltrim(round(Pixel2col(aStat[BUTTON_MSTATE_LCOL]),0)) 
     @ 11, 8 say "Mid mouse   " + ltrim(aStat[BUTTON_MSTATE_MCOUNT]) + ;
                 "-times pressed, last at row/col " + ;
                 ltrim(round(Pixel2row(aStat[BUTTON_MSTATE_MROW]),0)) + "/" + ;
                 ltrim(round(Pixel2col(aStat[BUTTON_MSTATE_MCOL]),0)) 
     @ 13, 8 say "Right mouse " + ltrim(aStat[BUTTON_MSTATE_RCOUNT]) + ;
                 "-times pressed, last at row/col " + ;
                 ltrim(round(Pixel2row(aStat[BUTTON_MSTATE_RROW]),0)) + "/" + ;
                 ltrim(round(Pixel2col(aStat[BUTTON_MSTATE_RCOL]),0)) 
     setpos(maxrow()-1, 0)
     wait
#endif                
     FT_MHIDECRS()

     SETMODE(nSaveRow,nSaveCol)
     setcolor( cSavClr )
     restscreen( 0, 0, maxrow(), maxcol(), cSavScr )
     devpos( maxrow(), 0 )

// Reset sensitivity

     FT_MSETSENS(nHoriz, nVert, nDouble)
   next
   wait "done..."
  RETURN nil
