// Test for FT_DSKFREE(), FT_DSKSIZE(), FT_MKDIR(), FT_RMDIR(), FT_TEMPFIL()
// FT_GETE(), 
// the source is available in vfs_fs2.prg and vfs_wrap.prg

FUNCTION MAIN(cDrive)
   local cFullDir, cDir := ""
   SET FONT "courier",10      // FlagShip GUI
   oApplic:Resize(25,80,,.T.) // FlagShip GUI

   ? "Test for disk functions"
#ifndef VFS_FS2TOOLS      
   ? "Note: some functions requires FS2 Toolbox. Since the library"
   ? "      was not found, default values are returned - see vfs_fs2.prg"
#endif  
   
   rr := row() +1
   if empty(cDrive)
      cDrive := space(80)
      cDir   := space(80)
      @ ++rr, 0 say "Drive or path or empty for current:" get cDrive pict "@S40"   
      @ ++rr, 0 say "temp directory to create & delete :" get cDir   pict "@S40"
      read
   endif
   cDrive := alltrim(cDrive)
   if empty(cDrive)
      cDrive := curdir()
   endif
   cDir := alltrim(cDir)

   setpos(rr+1,0)
   ? "FT_DSKFREE(" + cDrive + ")=", FT_DSKFREE(cDrive)
   ? "FT_DSKSIZE(" + cDrive + ")=", FT_DSKSIZE(cDrive)
   if !empty(cDir)
      ?
      cFullDir := truepath(cDir)
      if empty(cFullDir)      // file does not exist
         cFullDir := cDir
      endif
      ok := FT_MKDIR(cDir)
      ? "FT_MKDIR(" + cFullDir + ") =", ltrim(ok), "=", if(ok==0, "ok","falure") 
      ?? " exist:", file(cFullDir)
      ?
      aDir := Directory(cFullDir + PATH_SLASH + "*.*")
      rr := row() 
      yn := "N"
      @ ++rr, 0 say "remove '" + cFullDir + "' ? (y/n)" get yn pict "!" valid yn $ "YN"
      if len(aDir) > 0
         setpos(row() +1,0)
         if len(aDir) > 10
            aDir[10] := "etc..."
            aDir := asize(aDir, 10)
         endif
         ? "CAUTION: content of " + cFullDir color "R+" guicolor "R+"
         _displArrStd(aDir)
      endif
      read
      @ rr+1,0 clear
      if yn == "Y"
         ok := FT_RMDIR(cDir)
         ? "FT_RMDIR(" + cFullDir + ") =", ltrim(ok), "=", if(ok==0, "ok","falure")
         ?? " exist:", file(cFullDir)
      endif
   endif
   ?
   ? "FT_TEMPFIL(" + cDrive + ") returns:", cFile := FT_TEMPFIL(cDrive)
   ? "File '" + cFile + "' exist:", file(cFile)
   ?
   wait
   cls
   ? "Test for environment functions"
   cEnv := ""
   nEnv := FT_GETE(@cEnv)
   ? "FT_GETE(..) returns string with length", ltrim(nEnv), "="
   memoedit(cEnv, row()+1, 1, maxrow()-5, maxcol()-1, .F.)
   setpos(maxrow()-5,0)
   ?
   ? "NumLock  is " + if(FT_NUMLOCK(), "ON", "OFF")
   ? "CapsLock is " + if(FT_CAPLOCK(), "ON", "OFF")
   
   wait "done..."
   quit
   
         