/* This is a wrapper for video FT_*() functions for FlagShip 7 and later
 * Copyright 2012 by multisoft Datentechnik, Germany
 * Public domain for nanfor library used by FlagShip
 *
 * compile by supplied Makefile.*
 */

FUNCTION FT_CLS(r1, c1, r2, c2, nColor)      // replaces c/video1.c
   // nColor = nForegr + (nBackgr * 16)
   local cColor
   if valtype(nColor) == "N"
      cColor := ltrim(int(nColor % 16)) + "/" + ltrim(int(nColor/16))
      @ r1, c1, r2, c2 box space(9) COLOR (cColor) GUICOLOR (cColor)
   else
      @ r1, c1 clear to r2, c2 
   endif
   return
   
FUNCTION FT_GETMODE()                        // replaces prg/vidmode.prg (dummy, not applicable)
   return 0

FUNCTION FT_GETVCUR(p1,p2,p3)                // replaces prg/vidcur.prg (dummy, not applicable)
   return NIL

FUNCTION FT_RESTATT(r1, c1, r2, c2, cAttr)   // replaces asm/restatt.asm  (see Note) 
   // Note: apply for Terminal i/o only, dummy for GUI and Basic i/o  
   local ii, iAttr, cScreen
   if AppIoMode() $ "GB" 
      return
   endif
   cScreen := ScrUnix2dos(r1, c1, r2, c2, SaveScreen(r1, c1, r2, c2))
   iAttr := 1
   for ii := 2 to len(cScreen) step 2
      if iAttr <= len(cAttr)
         StrPoke(@cScreen, ii, StrPeek(cAttr, iAttr))
      endif
      iAttr++
   next
   ScrDos2unix(r1, c1, r2, c2, cScreen, .T.)
   return 
   
FUNCTION FT_REVATTR(r1, c1, r2, c2)          // replaces c/video1.c (see Note)
   // Note: apply for Terminal i/o only, dummy for GUI and Basic i/o  
   local ii, cScreen, iAttr, iFg, iBg
   if AppIoMode() $ "GB" 
      return
   endif
   cScreen := ScrUnix2dos(r1, c1, r2, c2, SaveScreen(r1, c1, r2, c2))
   for ii := 2 to len(cScreen) step 2
      iAttr := StrPeek(cScreen, ii)
      iFg   := int(iAttr % 16)
      iBg   := int(iAttr / 16)
      iAttr := iBg + int(16 * (iFg % 8))   // swap attrib, avoid blink
      StrPoke(@cScreen, ii, iAttr)
   next
   ScrDos2unix(r1, c1, r2, c2, cScreen, .T.)
   return
   
FUNCTION FT_REVCHR(r1, c1)                   // replaces c/video1.c (see Note)
   // Note: apply for Terminal i/o only, dummy for GUI and Basic i/o  
   FT_REVATTR(r1, c1, r1, c1)
   return  
   
FUNCTION FT_SAVEATT(r1, c1, r2, c2)          // replaces asm/saveatt.asm  (see Note)
   // Note: apply for Terminal i/o only, dummy for GUI and Basic i/o  
   local ii, cScreen, cAttr := ""
   if AppIoMode() $ "GB" 
      return ""
   endif
   cScreen := ScrUnix2dos(r1, c1, r2, c2, SaveScreen(r1, c1, r2, c2))
   for ii := 2 to len(cScreen) step 2
      cAttr += substr(cScreen, ii, 1)
   next
   return cAttr

FUNCTION FT_SETATTR(r1, c1, r2, c2, nColor)  // replaces c/video1.c (see Note)
   // Note: apply for Terminal i/o only, dummy for GUI and Basic i/o  
   // nColor = nForegr + (nBackgr * 16)
   local ii, cScreen
   if AppIoMode() $ "GB" 
      return
   endif
   cScreen := ScrUnix2dos(r1, c1, r2, c2, SaveScreen(r1, c1, r2, c2))
   for ii := 2 to len(cScreen) step 2
      StrPoke(@cScreen, ii, nColor)
   next
   ScrDos2unix(r1, c1, r2, c2, cScreen, .T.)
   return
   
FUNCTION FT_SETMODE()                        // replaces prg/vidmode.prg (dummy, not applicable)
   return NIL

FUNCTION FT_SETVPG(p1)                       // replaces prg/page.prg (dummy, not applicable) 
   return NIL
     
FUNCTION FT_SETVCUR(p1,p2,p3)                // replaces prg/vidcur.prg (dummy, not applicable)
   return NIL

FUNCTION FT_SHADOW(p1,p2,p3,p4,p5)           // replaces asm/shadow.asm (dummy, not applicable)
   return NIL
   
FUNCTION FT_VIDSTR(row, col, str, [nColor])  // replaces c/video1.c
   // nColor = nForegr + (nBackgr * 16)
   local cColor
   if valtype(nColor) == "N"
      cColor := ltrim(int(nColor % 16)) + "/" + ltrim(int(nColor/16))
      @ row, col SAY str COLOR (cColor) GUICOLOR (cColor)
   else
      @ row, col SAY str
   endif
   return

FUNCTION FT_WRTCHR(row, col, str, nColor)    // replaces c/video1.c
   FT_VIDSTR(row, col, str, nColor)
   return

